part of pegdart;

abstract class Grammar {
  
  Map<Symbol, PEGExpr> rules = {};
  
  PEGExpr rule(Symbol name, PEGExpr expression) => rules[name] = expression;
  
  dynamic parse(dynamic indexable) => rules[#start].parse(new Scope({}, null), new InputContext(indexable, rules));
  
  SeqMatcher m(String sequence) => new SeqMatcher(sequence);
  
  RegexMatcher r(String regex) => new RegexMatcher(regex);
  
  RuleExpression ref(Symbol rule) => new RuleExpression(rule);
  
  RangeExpression one_of(List<PEGExpr> matchers) => new RangeExpression(matchers);
  
  DelayExpression delay(ParserCallback parserCallback) => new DelayExpression(this, parserCallback);
  
  WildcardExpression get wildcard => new WildcardExpression();
  
  CutExpression get cut => new CutExpression();
  
  initialize();
  
}