import '../lib/pegdart.dart';
import 'package:unittest/unittest.dart';

main() {
  
  test('Simple string test.', () {
    var context = new InputContext("Some String.", {});
    expect(context.currentPosition, 0);
    expect(context.cutPosition, -1);
    expect(context.currentChar, 'S');
    context.cut();
    expect(context.cutPosition, 0);
    context.advancePosition();
    expect(context.currentPosition, 1);
    expect(context.currentChar, 'o');
    expect(context.cutPosition, 0);
  });
  
  test('Running past the end.', () {
    var context = new InputContext('A', {});
    expect(context.currentChar, 'A');
    context.advancePosition();
    expect(context.currentChar, null);
    context.advancePosition();
    expect(context.currentChar, null);
    expect(context.currentPosition, 2);
  });
  
  test('Jumping past cuts is not allowed.', () {
    var context = new InputContext('', {});
    context.cut();
    expect(context.cutPosition, 0);
    context.advancePosition();
    context.advancePosition();
    expect(context.currentPosition, 2);
    context.cut();
    expect(context.cutPosition, 2);
    expect(() => context.jumpTo(1), throwsA(new isInstanceOf<JumpCutException>()));
  });
  
  test('Array indexing test.', () {
    var context = new InputContext(['1', '2', '3'], {});
    expect(context.currentChar, '1');
    context.advancePosition();
    context.advancePosition();
    expect(context.currentChar, '3');
    context.advancePosition();
    expect(context.currentChar, null);
  });
  
}