import '../lib/pegdart.dart';
import 'package:unittest/unittest.dart';

class TestGrammar extends Grammar {
  initialize() {
    rule(#start, m('a').many + m('b').many);
  }
}

main() {
  
  List<dynamic> flatten(Iterable list) {
    return list.expand((x) => x).map((r) => r.match).toList();
  }
  
  test('One a and one b.', () {
    var grammar = new TestGrammar()..initialize();
    var result = grammar.parse('ab');
    expect(flatten(result), ['a', 'b']);
  });
  
  test('Many a and one b.', () {
    var grammar = new TestGrammar()..initialize();
    var result = grammar.parse('aaab');
    expect(flatten(result), ['a', 'a', 'a', 'b']);
  });
  
  test('Many a and many b.', () {
    var grammar = new TestGrammar()..initialize();
    var result = grammar.parse('aaabbb');
    expect(flatten(result), ['a', 'a', 'a', 'b', 'b', 'b']);
  });
  
  test('One a and many b.', () {
    var grammar = new TestGrammar()..initialize();
    var result = grammar.parse('abbb');
    expect(flatten(result), ['a', 'b', 'b', 'b']);
  });
  
  test('One a and no b.', () {
    var grammar = new TestGrammar()..initialize();
    expect(grammar.parse('a'), null);
  });
  
  test('Empty string.', () {
    var grammar = new TestGrammar()..initialize();
    expect(grammar.parse(''), null);
  });
  
}