import '../lib/pegdart.dart';
import 'package:unittest/unittest.dart';

main() {
  
  test('Simple character matching.', () {
    var context = new InputContext('a', {});
    var matcher = new SeqMatcher('a');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result.match, 'a');
  });
  
  test('Simple array matching.', () {
    var context = new InputContext(['a'], {});
    var matcher = new SeqMatcher('a');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result.match, ['a']);
  });
  
  test('Less simple character matching.', () {
    var context = new InputContext('ab', {});
    var matcher = new SeqMatcher('ab');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result.match, 'ab');
  });
  
  test('Less simple array matching.', () {
    var context = new InputContext(['a', 'b'], {});
    var matcher = new SeqMatcher('ab');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result.match, ['a', 'b']);
  });
  
  test('Not matching string.', () {
    var context = new InputContext('ab', {});
    var matcher = new SeqMatcher('ac');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result, null);
  });
  
  test('Not matching array.', () {
    var context = new InputContext(['a', 'b'], {});
    var matcher = new SeqMatcher('ac');
    DelayedRangeGetter result = matcher.parse(null, context);
    expect(result, null);
  });
  
}